//+------------------------------------------------------------------+
//|   #SpudFibo.mq4 - downloaded from ultimaforex.com                |
//+------------------------------------------------------------------+
#property  indicator_chart_window

extern string note1 = "Fibonacci colors";
extern color UpperFiboColor = Magenta;//RosyBrown;
extern color MainFiboColor = Magenta;//BurlyWood??
extern color LowerFiboColor = Magenta;//SlateBlue;
extern string note2 = "Draw main Fibonacci lines?";
extern bool  InnerFibs = true;

double HiPrice, LoPrice, Range;
datetime StartTime;

int init()
{
   return(0);
}

int deinit()
{
   ObjectDelete("FiboUp_W1");
   ObjectDelete("FiboDn_W1");
   ObjectDelete("FiboIn_W1");
   return(0);
}


//+------------------------------------------------------------------+
//| Draw Fibo                                                        |
//+------------------------------------------------------------------+

int DrawFibo()
{
	if(ObjectFind("FiboUp_W1") == -1)
		ObjectCreate("FiboUp_W1",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("FiboUp_W1",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboUp_W1",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboUp_W1",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("FiboUp_W1",OBJPROP_PRICE2,HiPrice);
	}
   ObjectSet("FiboUp_W1",OBJPROP_LEVELCOLOR,UpperFiboColor);
   ObjectSet("FiboUp_W1",OBJPROP_FIBOLEVELS,17);
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+0,0.0);	   ObjectSetFiboDescription("FiboUp_W1",0,"(100.0%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+1,0.125);	   ObjectSetFiboDescription("FiboUp_W1",1,"W(112.5%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+2,0.236);	   ObjectSetFiboDescription("FiboUp_W1",2,"W(123.6%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+3,0.382);	   ObjectSetFiboDescription("FiboUp_W1",3,"W(138.2%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+4,0.500);	   ObjectSetFiboDescription("FiboUp_W1",4,"W(150.0%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+5,0.618);	   ObjectSetFiboDescription("FiboUp_W1",5,"W(161.8%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+6,0.764);	   ObjectSetFiboDescription("FiboUp_W1",6,"W(176.4%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+7,0.875);	   ObjectSetFiboDescription("FiboUp_W1",7,"W(187.5%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+8,1.000);	   ObjectSetFiboDescription("FiboUp_W1",8,"W(200.0%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+9,1.125);	   ObjectSetFiboDescription("FiboUp_W1",9,"W(212.5%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+10,1.236);	ObjectSetFiboDescription("FiboUp_W1",10,"W(223.6%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+11,1.382);	ObjectSetFiboDescription("FiboUp_W1",11,"W(238.2%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+12,1.500);	ObjectSetFiboDescription("FiboUp_W1",12,"W(250.0%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+13,1.618);	ObjectSetFiboDescription("FiboUp_W1",13,"W(261.8%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+14,1.764);	ObjectSetFiboDescription("FiboUp_W1",14,"W(276.4%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+15,1.875);   ObjectSetFiboDescription("FiboUp_W1",15,"W(287.5%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+16,2.000);   ObjectSetFiboDescription("FiboUp_W1",16,"W(300.0%) - %$");
   
   ObjectSet("FiboUp_W1",OBJPROP_RAY,true);
   ObjectSet("FiboUp_W1",OBJPROP_BACK,true);

	if(ObjectFind("FiboDn_W1") == -1)
		ObjectCreate("FiboDn_W1",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("FiboDn_W1",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboDn_W1",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboDn_W1",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("FiboDn_W1",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("FiboDn_W1",OBJPROP_LEVELCOLOR,LowerFiboColor); 
   ObjectSet("FiboDn_W1",OBJPROP_FIBOLEVELS,19);
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+0,0.0);	   ObjectSetFiboDescription("FiboDn_W1",0,"(0.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+1,0.125);	   ObjectSetFiboDescription("FiboDn_W1",1,"W(-12.5%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+2,0.236);	   ObjectSetFiboDescription("FiboDn_W1",2,"W(-23.6%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+3,0.382);	   ObjectSetFiboDescription("FiboDn_W1",3,"W(-38.2%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+4,0.500);	   ObjectSetFiboDescription("FiboDn_W1",4,"W(-50.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+5,0.618);	   ObjectSetFiboDescription("FiboDn_W1",5,"W(-61.8%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+6,0.764);	   ObjectSetFiboDescription("FiboDn_W1",6,"W(-76.4%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+7,0.875);	   ObjectSetFiboDescription("FiboDn_W1",7,"W(-87.5%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+8,1.000);	   ObjectSetFiboDescription("FiboDn_W1",8,"W(-100.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+9,1.125);	   ObjectSetFiboDescription("FiboDn_W1",9,"W(-112.5%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+10,1.236);	ObjectSetFiboDescription("FiboDn_W1",10,"W(-123.6%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+11,1.382);	ObjectSetFiboDescription("FiboDn_W1",11,"W(-138.2%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+12,1.500);	ObjectSetFiboDescription("FiboDn_W1",12,"W(-150.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+13,1.618);	ObjectSetFiboDescription("FiboDn_W1",13,"W(-161.8%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+14,1.764);	ObjectSetFiboDescription("FiboDn_W1",14,"W(-176.4%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+15,1.875);	ObjectSetFiboDescription("FiboDn_W1",15,"W(-187.5%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+16,2.000);	ObjectSetFiboDescription("FiboDn_W1",16,"W(-200.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+17,2.125);	ObjectSetFiboDescription("FiboDn_W1",17,"W(-212.5%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+18,2.236);	ObjectSetFiboDescription("FiboDn_W1",18,"W(-223.6%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_RAY,true);
   ObjectSet("FiboDn_W1",OBJPROP_BACK,true);

	if(InnerFibs)
	{
		if(ObjectFind("FiboIn_W1") == -1)
			ObjectCreate("FiboIn_W1",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_W1*60,LoPrice);
		else
		{
			ObjectSet("FiboIn_W1",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboIn_W1",OBJPROP_TIME1, StartTime+PERIOD_W1*60);
			ObjectSet("FiboIn_W1",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboIn_W1",OBJPROP_PRICE2,LoPrice);
		}
   	ObjectSet("FiboIn_W1",OBJPROP_LEVELCOLOR,MainFiboColor); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIBOLEVELS,9);
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboIn_W1",0,"Weekly LOW (0.0) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+1,0.125);	ObjectSetFiboDescription("FiboIn_W1",1,"W(12.5) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+2,0.236);	ObjectSetFiboDescription("FiboIn_W1",2,"W(23.6) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+3,0.382);	ObjectSetFiboDescription("FiboIn_W1",3,"W(38.2) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+4,0.500);	ObjectSetFiboDescription("FiboIn_W1",4,"W(50.0) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+5,0.618);	ObjectSetFiboDescription("FiboIn_W1",5,"W(61.8) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+6,0.764);	ObjectSetFiboDescription("FiboIn_W1",6,"W(76.4) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+7,0.875);	ObjectSetFiboDescription("FiboIn_W1",7,"W(87.5) -  %$");
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+8,1.000);	ObjectSetFiboDescription("FiboIn_W1",8,"Weekly HIGH (100.0) -  %$");
   	ObjectSet("FiboIn_W1",OBJPROP_RAY,true);
   	ObjectSet("FiboIn_W1",OBJPROP_BACK,true);
   }
   else
	   ObjectDelete("FiboIn_W1");
}

//+-----------------------------------------------------------------------------------------------------------------------------+
//| Indicator start function                                                                                                    |
//+-----------------------------------------------------------------------------------------------------------------------------+

int start()
{
	int shift	= iBarShift(NULL,PERIOD_W1,Time[0]) + 1;	
	HiPrice		= iHigh(NULL,PERIOD_W1,shift);
	LoPrice		= iLow (NULL,PERIOD_W1,shift);
	StartTime	= iTime(NULL,PERIOD_W1,shift);


	Range = HiPrice-LoPrice;

	DrawFibo();

	return(0);
}
//+------------------------------------------------------------------+

